import java.io.* ;

public final class CombinatorK extends SKAtom
{
    public final static CombinatorK unique = new CombinatorK() ;

    private CombinatorK() {} 

    private final static SKApplication KK = new SKApplication(CombinatorK.unique,CombinatorK.unique) ;

    public final SKTerm abstractPlus(SKSymbol x)
    {
	return KK ;
    }

    public final SKTerm abstractPlusPlus(SKSymbol x)
    {
	return KK ;
    }

    public final SKTerm abstractPlusPlusPlus(SKSymbol x)
    {
	return KK ;
    }

    public final SKTerm abstractPlusPlusPlusPlus(SKSymbol x)
    {
	return KK ;
    }

    public final void writeTo(Writer writer)
	throws Exception
    {
	writer.write("K") ;
    }


    public boolean operate()
    {
	if (SKMachine.skStack.geThanTwo()) {

	    SKTerm        x    = SKMachine.skRegister.argument ;
	    SKApplication kxy  = SKMachine.skStack.pop() ;
	    SKApplication kxym = SKMachine.skStack.pop() ;

	    kxym.function = x ;

	    x.replace(kxy) ;

	    SKMachine.skRegister = kxym ;

	    SKMachine.reductionCount++ ;
	    return true ;
	}

	if (SKMachine.skStack.geThanOne()) {

	    SKApplication kxy = SKMachine.skStack.pop() ;

	    SKMachine.skRegister.argument.replace(kxy) ;

	    SKMachine.skRegister = kxy ;

	    SKMachine.reductionCount++ ;
	    return true ;
	} 

	return false ;
    }

    public boolean isK()
    {
	return true ;
    }

}
