import java.io.* ;

public final class CombinatorS extends SKAtom
{
    public final static CombinatorS unique = new CombinatorS() ;

    private CombinatorS() {} 

    private final static SKApplication KS = new SKApplication(CombinatorK.unique,CombinatorS.unique) ;

    public final SKTerm abstractPlus(SKSymbol x)
    {
	return KS ;
    }

    public final SKTerm abstractPlusPlus(SKSymbol x)
    {
	return KS ;
    }

    public final SKTerm abstractPlusPlusPlus(SKSymbol x)
    {
	return KS ;
    }

    public final SKTerm abstractPlusPlusPlusPlus(SKSymbol x)
    {
	return KS ;
    }

    public final void writeTo(Writer writer)
	throws Exception
    {
	writer.write("S") ;
    }

    public boolean operate()
    {
	if (SKMachine.skStack.geThanTwo()) {

	    SKTerm        y    = SKMachine.skStack.pop().argument ; // sxy.argument
	    SKApplication sxyz = SKMachine.skStack.top() ;
	    SKTerm        z    = sxyz.argument ;

	    sxyz.function 
		= SKMachine.skRegister
		= new SKApplication(SKMachine.skRegister.argument,z) ; // [sx.argument . z] = [x . z] = xz

	    sxyz.argument
		= new SKApplication(y,z) ;

	    SKMachine.reductionCount++ ;
	    return true ;
	} 

	return false ;
    }

    public boolean isS()
    {
	return true ;
    }

}
