import java.text.* ;
import java.io.* ;
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;

public class SKInterpret
{

    public static SKTerm interpret(SKFrame skFrame, String text)
    {
 	try {

 	    SKParser skParser = new SKParser(new StringReader(text)) ;

	    skParser.yyparse() ;

	    if (skParser.errorLine != -1)
		throw new Exception("Cannot decode a term") ;

	    SKTerm term = skParser.expression ;

	    skParser = null ;

	    if (term == null)
		throw new Exception("Cannot decode a term") ;

	    return term.interpret() ;

	    
 	} catch (Throwable e) {
	    JOptionPane.showMessageDialog(skFrame,
					  "Error: " + e.getMessage() + "\nInterpretation aborted",
					  "Interpretation aborted",
					  JOptionPane.ERROR_MESSAGE,
					  SKUtils.messageIcon) ;
	    e.printStackTrace() ;
	    return null ;
 	}
    }

}