public class SKArobase extends SKSymbol
{
    public final SKSymbol symbol ;

    public SKArobase(SKSymbol symbol)
    {
	super("@" + symbol.name) ;
	this.symbol = symbol ;
    }

    public SKTerm elimArobases()
    {
	return (symbol.value != null) ? symbol.value : symbol ;
    }

    public boolean isSuccessor()
    {
	return symbol.isSuccessor() ;
    }

    public boolean isB()
    {
	return symbol.isB() ;
    }

    public boolean isNumber()
    {
	return symbol.isNumber() ;
    }

    public boolean isKI()
    {
	return symbol.isKI() ;
    }

    public boolean isW()
    {
	return symbol.isW() ;
    }

    public boolean isC()
    {
	return symbol.isC() ;
    }

    public SKList isList()
    {
	return symbol.isList() ;
    }

    public SKList isCdr()
    {
	return symbol.isCdr() ;
    }

}
