//### This file created by BYACC 1.8(/Java extension  1.15)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//###           06 Aug 00  -- Bob Jamison -- made state variables class-global
//###           03 Jan 01  -- Bob Jamison -- improved flags, tracing
//###           16 May 01  -- Bob Jamison -- added custom stack sizing
//###           04 Mar 02  -- Yuval Oren  -- improved java performance, added options
//###           14 Mar 02  -- Tomas Hurka -- -d support, static initializer workaround
//### Please send bug reports to tom@hukatronic.cz
//### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";






//#line 2 "SK.yacc"
  import java.io.* ;
//#line 19 "SKParser.java"




public class SKParser
{

boolean yydebug;        //do I want debug output?
int yynerrs;            //number of errors so far
int yyerrflag;          //was there an error?
int yychar;             //the current working character

//########## MESSAGES ##########
//###############################################################
// method: debug
//###############################################################
void debug(String msg)
{
  if (yydebug)
    System.out.println(msg);
}

//########## STATE STACK ##########
final static int YYSTACKSIZE = 262144;  //maximum stack size
int statestk[] = new int[YYSTACKSIZE]; //state stack
int stateptr;
int stateptrmax;                     //highest index of stackptr
int statemax;                        //state when highest index reached
//###############################################################
// methods: state stack push,pop,drop,peek
//###############################################################
final void state_push(int state)
{
  try {
		stateptr++;
		statestk[stateptr]=state;
	 }
	 catch (ArrayIndexOutOfBoundsException e) {
     int oldsize = statestk.length;
     int newsize = oldsize * 2;
     int[] newstack = new int[newsize];
     System.arraycopy(statestk,0,newstack,0,oldsize);
     statestk = newstack;
     statestk[stateptr]=state;
  }
}
final int state_pop()
{
  return statestk[stateptr--];
}
final void state_drop(int cnt)
{
  stateptr -= cnt; 
}
final int state_peek(int relative)
{
  return statestk[stateptr-relative];
}
//###############################################################
// method: init_stacks : allocate and prepare stacks
//###############################################################
final boolean init_stacks()
{
  stateptr = -1;
  val_init();
  return true;
}
//###############################################################
// method: dump_stacks : show n levels of the stacks
//###############################################################
void dump_stacks(int count)
{
int i;
  System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
  for (i=0;i<count;i++)
    System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
  System.out.println("======================");
}


//########## SEMANTIC VALUES ##########
//public class SKParserVal is defined in SKParserVal.java


String   yytext;//user variable to return contextual strings
SKParserVal yyval; //used to return semantic vals from action routines
SKParserVal yylval;//the 'lval' (result) I got from yylex()
SKParserVal valstk[];
int valptr;
//###############################################################
// methods: value stack push,pop,drop,peek.
//###############################################################
void val_init()
{
  valstk=new SKParserVal[YYSTACKSIZE];
  yyval=new SKParserVal();
  yylval=new SKParserVal();
  valptr=-1;
}
void val_push(SKParserVal val)
{
  if (valptr>=YYSTACKSIZE)
    return;
  valstk[++valptr]=val;
}
SKParserVal val_pop()
{
  if (valptr<0)
    return new SKParserVal();
  return valstk[valptr--];
}
void val_drop(int cnt)
{
int ptr;
  ptr=valptr-cnt;
  if (ptr<0)
    return;
  valptr = ptr;
}
SKParserVal val_peek(int relative)
{
int ptr;
  ptr=valptr-relative;
  if (ptr<0)
    return new SKParserVal();
  return valstk[ptr];
}
final SKParserVal dup_yyval(SKParserVal val)
{
  SKParserVal dup = new SKParserVal();
  dup.ival = val.ival;
  dup.dval = val.dval;
  dup.sval = val.sval;
  dup.obj = val.obj;
  return dup;
}
//#### end semantic value section ####
public final static short S=257;
public final static short K=258;
public final static short I=259;
public final static short Dieze=260;
public final static short Arobase=261;
public final static short INTEGER=262;
public final static short SYMBOL=263;
public final static short LET=264;
public final static short EGAL=265;
public final static short DOUBLE_POINT_VIRGULE=266;
public final static short UNDEF=267;
public final static short LEFT_BRACKET=268;
public final static short COMMA=269;
public final static short DOT=270;
public final static short RIGHT_BRACKET=271;
public final static short LEFT_PAREN=272;
public final static short RIGHT_PAREN=273;
public final static short LAMBDA_PLUS=274;
public final static short LAMBDA_PLUS_PLUS=275;
public final static short LAMBDA_PLUS_PLUS_PLUS=276;
public final static short LAMBDA_PLUS_PLUS_PLUS_PLUS=277;
public final static short YYERRCODE=256;
final static short yylhs[] = {                           -1,
    0,    0,    2,    1,    1,    4,    4,    5,    3,    3,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    7,    7,    7,
};
final static short yylen[] = {                            2,
    1,    1,    2,    0,    2,    5,    3,    1,    1,    2,
    1,    1,    1,    1,    1,    1,    3,    3,    6,    6,
    6,    6,    2,    3,    3,    1,
};
final static short yydefred[] = {                         0,
   11,   12,   13,   14,    0,   16,    8,    0,    0,    0,
    0,    0,    1,    2,    0,    0,   15,    0,   23,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    3,    5,
   10,    0,    7,    0,    0,   17,    0,    0,    0,    0,
   18,    0,   25,   24,    0,    0,    0,    0,    6,    0,
    0,    0,    0,   19,   20,   21,   22,
};
final static short yydgoto[] = {                         12,
   13,   14,   15,   16,   17,   18,   23,
};
final static short yysindex[] = {                      -198,
    0,    0,    0,    0, -253,    0,    0, -253, -253, -182,
 -219,    0,    0,    0, -260, -262,    0, -182,    0, -252,
 -251, -266, -254, -253, -253, -253, -253, -255,    0,    0,
    0, -182,    0, -182, -182,    0, -250, -248, -247, -244,
    0, -235,    0,    0, -182, -182, -182, -182,    0, -241,
 -240, -228, -227,    0,    0,    0,    0,
};
final static short yyrindex[] = {                        19,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   19,    0, -257,    0,    0,
    0, -224,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
final static short yygindex[] = {                         0,
   32,    0,  -11,    0,    3,   -9,   16,
};
final static int YYTABLESIZE=90;
static short yytable[];
static { yytable();}
static void yytable(){
yytable = new short[]{                         28,
   22,    8,   34,   35,    9,   29,   31,   19,    9,    7,
   20,   21,   32,    9,   33,    9,   36,   41,    4,   45,
   42,   46,   47,   44,   22,   48,   37,   38,   39,   40,
   49,   54,   55,   50,   51,   52,   53,    1,    2,    3,
    4,    5,    6,    7,   56,   57,   26,   30,   10,   43,
    0,    0,   11,    0,   24,   25,   26,   27,    1,    2,
    3,    4,    5,    6,    7,    8,    0,    0,    9,   10,
    0,    0,    0,   11,    1,    2,    3,    4,    5,    6,
    7,    0,    0,    0,    0,   10,    0,    0,    0,   11,
};
}
static short yycheck[];
static { yycheck(); }
static void yycheck() {
yycheck = new short[] {                         11,
   10,  264,  269,  270,  267,  266,   18,    5,  266,  263,
    8,    9,  265,  271,  266,  273,  271,  273,    0,  270,
   32,  270,  270,   35,   34,  270,   24,   25,   26,   27,
  266,  273,  273,   45,   46,   47,   48,  257,  258,  259,
  260,  261,  262,  263,  273,  273,  271,   16,  268,   34,
   -1,   -1,  272,   -1,  274,  275,  276,  277,  257,  258,
  259,  260,  261,  262,  263,  264,   -1,   -1,  267,  268,
   -1,   -1,   -1,  272,  257,  258,  259,  260,  261,  262,
  263,   -1,   -1,   -1,   -1,  268,   -1,   -1,   -1,  272,
};
}
final static short YYFINAL=12;
final static short YYMAXTOKEN=277;
final static String yyname[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,"S","K","I","Dieze","Arobase","INTEGER","SYMBOL","LET","EGAL",
"DOUBLE_POINT_VIRGULE","UNDEF","LEFT_BRACKET","COMMA","DOT","RIGHT_BRACKET",
"LEFT_PAREN","RIGHT_PAREN","LAMBDA_PLUS","LAMBDA_PLUS_PLUS",
"LAMBDA_PLUS_PLUS_PLUS","LAMBDA_PLUS_PLUS_PLUS_PLUS",
};
final static String yyrule[] = {
"$accept : to_read",
"to_read : definitions",
"to_read : expression",
"expression : term_sequence DOUBLE_POINT_VIRGULE",
"definitions :",
"definitions : definition definitions",
"definition : LET symbol EGAL term_sequence DOUBLE_POINT_VIRGULE",
"definition : UNDEF symbol DOUBLE_POINT_VIRGULE",
"symbol : SYMBOL",
"term_sequence : term",
"term_sequence : term term_sequence",
"term : S",
"term : K",
"term : I",
"term : Dieze",
"term : symbol",
"term : INTEGER",
"term : LEFT_BRACKET inner_list RIGHT_BRACKET",
"term : LEFT_PAREN term_sequence RIGHT_PAREN",
"term : LEFT_PAREN LAMBDA_PLUS symbol DOT term_sequence RIGHT_PAREN",
"term : LEFT_PAREN LAMBDA_PLUS_PLUS symbol DOT term_sequence RIGHT_PAREN",
"term : LEFT_PAREN LAMBDA_PLUS_PLUS_PLUS symbol DOT term_sequence RIGHT_PAREN",
"term : LEFT_PAREN LAMBDA_PLUS_PLUS_PLUS_PLUS symbol DOT term_sequence RIGHT_PAREN",
"term : Arobase symbol",
"inner_list : term DOT term_sequence",
"inner_list : term COMMA inner_list",
"inner_list : term",
};

//#line 169 "SK.yacc"

private static final boolean DEBUG = false ;

private Writer writer ;

public SKTerm expression = null ;

/* the "bad" value */
private SKParserVal nullSKParserVal = new SKParserVal((SKTerm)null) ;
  
/* a reference to the lexer object */
private SKLexer skLexer;

/* interface to the lexer */
private int yylex () 
{
    int yyl_return = -1;

    try {
      yylval = nullSKParserVal ;
      yyl_return = skLexer.yylex();
    }
    catch (Exception e) {}
    catch (Throwable e) {}

    return yyl_return;
}

/* error reporting */

public int errorLine = -1 ;

public void yyerror (String error) 
{
  errorLine = skLexer.getLine() ;
}

/* lexer is created in the constructor */
public SKParser(Reader r) 
{
  if (DEBUG) {
    try {
      writer = new BufferedWriter(new FileWriter("ski.dbg")) ;
    } catch (Exception e) { e.printStackTrace() ; }
  }

  skLexer = new SKLexer(r,this);
}

//#line 285 "SKParser.java"
//###############################################################
// method: yylexdebug : check lexer state
//###############################################################
void yylexdebug(int state,int ch)
{
String s=null;
  if (ch < 0) ch=0;
  if (ch <= YYMAXTOKEN) //check index bounds
     s = yyname[ch];    //now get it
  if (s==null)
    s = "illegal-symbol";
  debug("state "+state+", reading "+ch+" ("+s+")");
}





//The following are now global, to aid in error reporting
int yyn;       //next next thing to do
int yym;       //
int yystate;   //current parsing state from state table
String yys;    //current token string


//###############################################################
// method: yyparse : parse input and execute indicated items
//###############################################################
int yyparse()
{
boolean doaction;
  init_stacks();
  yynerrs = 0;
  yyerrflag = 0;
  yychar = -1;          //impossible char forces a read
  yystate=0;            //initial state
  state_push(yystate);  //save it
  val_push(yylval);     //save empty value
  while (true) //until parsing is done, either correctly, or w/error
    {
    doaction=true;
    if (yydebug) debug("loop"); 
    //#### NEXT ACTION (from reduction table)
    for (yyn=yydefred[yystate];yyn==0;yyn=yydefred[yystate])
      {
      if (yydebug) debug("yyn:"+yyn+"  state:"+yystate+"  yychar:"+yychar);
      if (yychar < 0)      //we want a char?
        {
        yychar = yylex();  //get next token
        if (yydebug) debug(" next yychar:"+yychar);
        //#### ERROR CHECK ####
        if (yychar < 0)    //it it didn't work/error
          {
          yychar = 0;      //change it to default string (no -1!)
          if (yydebug)
            yylexdebug(yystate,yychar);
          }
        }//yychar<0
      yyn = yysindex[yystate];  //get amount to shift by (shift index)
      if ((yyn != 0) && (yyn += yychar) >= 0 &&
          yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
        {
        if (yydebug)
          debug("state "+yystate+", shifting to state "+yytable[yyn]);
        //#### NEXT STATE ####
        yystate = yytable[yyn];//we are in a new state
        state_push(yystate);   //save it
        val_push(yylval);      //push our lval as the input for next rule
        yychar = -1;           //since we have 'eaten' a token, say we need another
        if (yyerrflag > 0)     //have we recovered an error?
           --yyerrflag;        //give ourselves credit
        doaction=false;        //but don't process yet
        break;   //quit the yyn=0 loop
        }

    yyn = yyrindex[yystate];  //reduce
    if ((yyn !=0 ) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
      {   //we reduced!
      if (yydebug) debug("reduce");
      yyn = yytable[yyn];
      doaction=true; //get ready to execute
      break;         //drop down to actions
      }
    else //ERROR RECOVERY
      {
      if (yyerrflag==0)
        {
        yyerror("syntax error");
        yynerrs++;
        }
      if (yyerrflag < 3) //low error count?
        {
        yyerrflag = 3;
        while (true)   //do until break
          {
          if (stateptr<0)   //check for under & overflow here
            {
            yyerror("stack underflow. aborting...");  //note lower case 's'
            return 1;
            }
          yyn = yysindex[state_peek(0)];
          if ((yyn != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
            if (yydebug)
              debug("state "+state_peek(0)+", error recovery shifting to state "+yytable[yyn]+" ");
            yystate = yytable[yyn];
            state_push(yystate);
            val_push(yylval);
            doaction=false;
            break;
            }
          else
            {
            if (yydebug)
              debug("error recovery discarding state "+state_peek(0)+" ");
            if (stateptr<0)   //check for under & overflow here
              {
              yyerror("Stack underflow. aborting...");  //capital 'S'
              return 1;
              }
            state_pop();
            val_pop();
            }
          }
        }
      else            //discard this token
        {
        if (yychar == 0)
          return 1; //yyabort
        if (yydebug)
          {
          yys = null;
          if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
          if (yys == null) yys = "illegal-symbol";
          debug("state "+yystate+", error recovery discards token "+yychar+" ("+yys+")");
          }
        yychar = -1;  //read another
        }
      }//end error recovery
    }//yyn=0 loop
    if (!doaction)   //any reason not to proceed?
      continue;      //skip action
    yym = yylen[yyn];          //get count of terminals on rhs
    if (yydebug)
      debug("state "+yystate+", reducing "+yym+" by rule "+yyn+" ("+yyrule[yyn]+")");
    if (yym>0)                 //if count of rhs not 'nil'
      yyval = val_peek(yym-1); //get current semantic value
    yyval = dup_yyval(yyval); //duplicate yyval if ParserVal is used as semantic value
    switch(yyn)
      {
//########## USER-SUPPLIED ACTIONS ##########
case 1:
//#line 23 "SK.yacc"
{ 
  yyval = nullSKParserVal ;
}
break;
case 2:
//#line 27 "SK.yacc"
{ 
  expression = (SKTerm)(val_peek(0).obj) ;
  yyval = nullSKParserVal ;
}
break;
case 3:
//#line 35 "SK.yacc"
{ 
  yyval = new SKParserVal(SKBuilder.buildApplication((SKSequence)(val_peek(1).obj))) ; 
}
break;
case 4:
//#line 42 "SK.yacc"
{ 
  yyval = nullSKParserVal ;
}
break;
case 5:
//#line 46 "SK.yacc"
{ 
  yyval = nullSKParserVal ;
}
break;
case 6:
//#line 53 "SK.yacc"
{
  SKBuilder.registerDefinition((SKSymbol)(val_peek(3).obj),
			       SKBuilder.buildApplication((SKSequence)(val_peek(1).obj))) ; 
  yyval = new SKParserVal((SKTerm)null) ; 

  if (DEBUG) {
    try {
      writer.write("Rule: LET symbol EGAL term_sequence DOUBLE_POINT_VIRGULE\nwith symbol = ") ;
      ((SKSymbol)(val_peek(3).obj)).writeTo(writer) ;
      writer.write("\nand term_sequence = ") ;
      ((SKSequence)(val_peek(1).obj)).writeTo(writer) ;
      writer.write("\nresult = ") ;
      (SKBuilder.buildApplication((SKSequence)(val_peek(1).obj))).writeTo(writer) ;
      writer.write("\n\n") ;
      writer.flush() ;
    } catch (Exception e) { e.printStackTrace() ; }
  }
}
break;
case 7:
//#line 72 "SK.yacc"
{
  SKBuilder.registerDefinition((SKSymbol)(val_peek(1).obj),null) ;
  yyval = new SKParserVal((SKTerm)null) ; 
}
break;
case 8:
//#line 80 "SK.yacc"
{
  yyval = new SKParserVal(SKBuilder.getSymbol(skLexer.yytext())) ;
}
break;
case 9:
//#line 86 "SK.yacc"
{ 
  yyval = new SKParserVal(new SKSequence((SKTerm)(val_peek(0).obj))) ;
}
break;
case 10:
//#line 90 "SK.yacc"
{ 
  ((SKSequence)(val_peek(0).obj)).add((SKTerm)(val_peek(1).obj)) ;
  yyval = val_peek(0) ; 
}
break;
case 11:
//#line 98 "SK.yacc"
{ 
  yyval = new SKParserVal(CombinatorS.unique) ;  
}
break;
case 12:
//#line 102 "SK.yacc"
{ 
  yyval = new SKParserVal(CombinatorK.unique) ;  
}
break;
case 13:
//#line 106 "SK.yacc"
{ 
  yyval = new SKParserVal(CombinatorI.unique) ;  
}
break;
case 14:
//#line 110 "SK.yacc"
{ 
  yyval = new SKParserVal(CombinatorDieze.unique) ;  
}
break;
case 15:
//#line 114 "SK.yacc"
{ 
  yyval = val_peek(0) ;
}
break;
case 16:
//#line 118 "SK.yacc"
{ 
  yyval = new SKParserVal(SKBuilder.getNumber(Integer.parseInt(skLexer.yytext()))) ;  
}
break;
case 17:
//#line 122 "SK.yacc"
{ 
  yyval = val_peek(1) ; 
}
break;
case 18:
//#line 126 "SK.yacc"
{ 
  yyval = new SKParserVal(SKBuilder.buildApplication((SKSequence)(val_peek(1).obj))) ; 
}
break;
case 19:
//#line 130 "SK.yacc"
{
  yyval = new SKParserVal(SKBuilder.lambdaPlus((SKSymbol)(val_peek(3).obj),SKBuilder.buildApplication((SKSequence)(val_peek(1).obj)))) ;
}
break;
case 20:
//#line 134 "SK.yacc"
{
  yyval = new SKParserVal(SKBuilder.lambdaPlusPlus((SKSymbol)(val_peek(3).obj),SKBuilder.buildApplication((SKSequence)(val_peek(1).obj)))) ;
}
break;
case 21:
//#line 138 "SK.yacc"
{
  yyval = new SKParserVal(SKBuilder.lambdaPlusPlusPlus((SKSymbol)(val_peek(3).obj),SKBuilder.buildApplication((SKSequence)(val_peek(1).obj)))) ;
}
break;
case 22:
//#line 142 "SK.yacc"
{
  yyval = new SKParserVal(SKBuilder.lambdaPlusPlusPlusPlus((SKSymbol)(val_peek(3).obj),SKBuilder.buildApplication((SKSequence)(val_peek(1).obj)))) ;
}
break;
case 23:
//#line 146 "SK.yacc"
{
  yyval = new SKParserVal(SKBuilder.buildArobase((SKSymbol)(val_peek(0).obj))) ;
}
break;
case 24:
//#line 153 "SK.yacc"
{ 
  yyval = new SKParserVal(SKBuilder.getCons((SKTerm)(val_peek(2).obj),SKBuilder.buildApplication((SKSequence)(val_peek(0).obj)))) ;
}
break;
case 25:
//#line 157 "SK.yacc"
{
  yyval = new SKParserVal(SKBuilder.getCons((SKTerm)(val_peek(2).obj),(SKTerm)(val_peek(0).obj))) ;
}
break;
case 26:
//#line 161 "SK.yacc"
{ 
  yyval = new SKParserVal(SKBuilder.getCons((SKTerm)(val_peek(0).obj))) ; 
}
break;
//#line 608 "SKParser.java"
//########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch
    //#### Now let's reduce... ####
    if (yydebug) debug("reduce");
    state_drop(yym);             //we just reduced yylen states
    yystate = state_peek(0);     //get new state
    val_drop(yym);               //corresponding value drop
    yym = yylhs[yyn];            //select next TERMINAL(on lhs)
    if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
      {
      if (yydebug) debug("After reduction, shifting from state 0 to state "+YYFINAL+"");
      yystate = YYFINAL;         //explicitly say we're done
      state_push(YYFINAL);       //and save it
      val_push(yyval);           //also save the semantic value of parsing
      if (yychar < 0)            //we want another character?
        {
        yychar = yylex();        //get next character
        if (yychar<0) yychar=0;  //clean, if necessary
        if (yydebug)
          yylexdebug(yystate,yychar);
        }
      if (yychar == 0)          //Good exit (if lex returns 0 ;-)
         break;                 //quit the loop--all DONE
      }//if yystate
    else                        //else not done yet
      {                         //get next state and push, for next yydefred[]
      yyn = yygindex[yym];      //find out where to go
      if ((yyn != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn]; //get new state
      else
        yystate = yydgoto[yym]; //else go to new defred
      if (yydebug) debug("after reduction, shifting from state "+state_peek(0)+" to state "+yystate+"");
      state_push(yystate);     //going again, so push state & val...
      val_push(yyval);         //for next action
      }
    }//main loop
  return 0;//yyaccept!!
}
//## end of method parse() ######################################



//## run() --- for Thread #######################################
//## The -Jnorun option was used ##
//## end of method run() ########################################



//## Constructors ###############################################
/**
 * Default constructor.  Turn off with -Jnoconstruct .

 */
public SKParser()
{
  //nothing to do
}


/**
 * Create a parser, setting the debug to true or false.
 * @param debugMe true for debugging, false for no debug.
 */
public SKParser(boolean debugMe)
{
  yydebug=debugMe;
}
//###############################################################



}
//################### END OF CLASS ##############################
