import java.awt.* ;
import javax.swing.* ;

public final class SKPredefineds extends JPanel
{
    private final SKPredefinedCombinators skPredefinedCombinators ;
    private final SKPredefinedBooleans    skPredefinedBooleans ;
    private final SKPredefinedLists       skPredefinedLists ;
    private final SKPredefinedNaturals    skPredefinedNaturals ;

    public SKPredefineds()
    {
	setBorder(BorderFactory.createTitledBorder("Predefined")) ;
	setLayout(new BoxLayout(this,BoxLayout.X_AXIS)) ;

	add(skPredefinedCombinators = new SKPredefinedCombinators()) ;
	add(skPredefinedBooleans    = new SKPredefinedBooleans()) ;
	add(skPredefinedLists       = new SKPredefinedLists()) ;
	add(skPredefinedNaturals    = new SKPredefinedNaturals()) ;
    }
	
    public final void loadDefineds()
    {
	skPredefinedCombinators .loadDefineds() ;
	skPredefinedBooleans    .loadDefineds() ;
	skPredefinedLists       .loadDefineds() ;
	skPredefinedNaturals    .loadDefineds() ;
    }
}

