import java.io.* ;

public abstract class SKTerm
{

    public SKTerm elimArobases()
    {
	return this ;
    }

    public boolean isAtom()
    {
	return false ;
    }

    public boolean isApplication()
    {
	return false ;
    }

    public abstract SKTerm abstractPlus(SKSymbol x) ;

    public abstract SKTerm abstractPlusPlus(SKSymbol x) ;

    public abstract SKTerm abstractPlusPlusPlus(SKSymbol x) ;

    public abstract SKTerm abstractPlusPlusPlusPlus(SKSymbol x) ;

    public boolean freeOf(SKSymbol x)
    {
	return true ;
    }

    public abstract void writeTo(Writer writer) 
	throws Exception ;

    public void writeToWithArobase(Writer writer) 
	throws Exception
    {
	writeTo(writer) ;
    }

    public final String toString()
    {
	try {
	    StringWriter writer = new StringWriter() ;
	    writeTo(writer) ;
	    writer.close() ;

	    return writer.toString() ;
	} catch (Exception e) {
	    e.printStackTrace() ;
 	}
	return "#errorToString" ;
    }

    public abstract boolean auxPushInStack() ;
    
    public abstract boolean operate() ;

    public abstract  SKTerm eval(int mode) ;

    public abstract void evalFull() ;
	    
    public abstract SKTerm evalOneStep() ; 

    public abstract void replace(SKApplication app) ;
	    
    public SKTerm getValue()
    { 
	return this ;
    }


    public SKTerm interpret()
    {
	return this ;
    }

    public boolean isSuccessor()
    {
	return false ;
    }

    public boolean isNumber()
    {
	return false ;
    }

    public boolean isS()
    {
	return false ;
    }

    public boolean isB()
    {
	return false ;
    }

    public int numberValue()
    {
	return 0 ;
    }

    public boolean isS1KS1()
    {
	return false ;
    }

    public boolean isKS()
    {
	return false ;
    }

    public boolean isK()
    {
	return false ;
    }

    public boolean isI()
    {
	return false ;
    }

    public boolean isSK()
    {
	return false ;
    }

    public boolean isW()
    {
	return false ;
    }

    public boolean isKI()
    {
	return false ;
    }

    public boolean isSS()
    {
	return false ;
    }

    public boolean isC()
    {
	return false ;
    }
    public boolean isKK()
    {
	return false ;
    }

    public boolean isS1BBS1()
    {
	return false ;
    }

    public boolean isBBS()
    {
	return false ;
    }

    public boolean isBB()
    {
	return false ;
    }

    public boolean isSI()
    {
	return false ;
    }

    public SKList isList()
    {
	return null ;
    }

    public SKList isCdr()
    {
	return null ;
    }

    public SKTerm isCar()
    {
	return null ;
    }

    public SKTerm isCarAux()
    {
	return null ;
    }

    public SKTerm isCarAuxAux()
    {
	return null ;
    }

    public long nodeCount()
    {
	return 0L ;
    }

}

