public final class SKWorkerEvent
{
    public final static int FRAME_SET_RUNNING = 0 ;
    public final static int FRAME_SET_NOT_RUNNING = 1 ;
    public final static int DISPLAY_RESULT = 2 ;
    public final static int DISPLAY_ERROR = 3 ;

    public int    eventCode ;
    public long   duration ;
    public SKTerm result ;
    public long   reductionCount ;
    public String error ;

    public SKWorkerEvent(int eventCode)
    {
	this.eventCode = eventCode ;
    }

    public SKWorkerEvent(int eventCode, String error)
    {
	this.eventCode = eventCode ;
	this.error     = error ;
    }

    public SKWorkerEvent(int eventCode, long duration, SKTerm result, long reductionCount)
    {
	this.eventCode      = eventCode ;
	this.duration       = duration ;
	this.result         = result ;
	this.reductionCount = reductionCount ;
    }


}
